/*************************************************************************
 * s2k2smi.c  Converter from s2k subtitle to smi.
 *
 * Copyright (c) 2003 George Shuklin
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *   
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *   
 * You should have received a copy of the GNU General Public License along
 * with this program (see the file COPYING); if not, write to the Free 
 * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 * MA  02111-1307  USA  or visit http://www.gnu.org/copyleft/gpl.html
 *
 *************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

const char head[]="<SAMI>\n\
<HEAD>\n\
<title>\n\
Autoconverted from %s\n\
</title>\n\
<!--\n\
s2k2smi converter\n\
(c) George Shuklin gs@shounen.ru, 2:5030/1377\n\
\n\
http://shounen.ru/soft/s2k2smi/\n\
-->\n\
<style type=\"text/css\">\n\
<!--\n\
 P {margin-left:8pt; margin-right:8pt; margin-bottom:2pt; margin-top:2pt;\n\
   text-align:center; font-size:%dpt; font-family:arial, sans-serif;\n\
   font-weight:normal; color:rgb(%d,%d,%d);}\n\
.ENCC {Name:English; lang:en-US; SAMIType:CC;}\n\
#STDPrn {Name:Standard Print; font-size:28pt;}\n\
#LargePrn {Name:Large Print; font-size:22pt;}\n\
#SmallPrn {Name:Small Print; font-size:20pt;}\n\
-->\n\
</style>\n\
</head><body>\n";

int help(){
return puts("*.s2k to *.smi converter. (c) George Shuklin, 2003\nusage: s2k2smi file.s2k [file.smi]");
}

const char foot[]="</body></sami>";

char* newname(char* oldname){
	int c=strlen(oldname);
	char *temp=malloc(c+5);
	while(c){
		if (oldname[c]=='.'){ 
			strcpy(temp,oldname);
			temp[c]=0;
			strcat(temp,".smi");
			return temp;
		}
		c--;
	}
	strcpy(temp,oldname);
	strcat(temp,".smi");
	return temp;
}

int henno_cmp(char *one, char *two){
//cmp lines, till \0 or \= char apear.	
	int c=0;
	while(one[c]==two[c]){
		c++;
		if(one[c]=='='||!one[c]){
			if(two[c]=='='||!two[c]) return 0;//ok
			else return 1; //not ok
		}
	}
	return 1;//not ok
}


int main(int argc, char* argv[]){
	char* from;
	char *to;
	char buffer[65536];
	int timer=0;
	FILE* FROM;
	FILE* TO;
	if(argc<2) return help();
	if(argv[1][1]=='?'||!strcmp(argv[1],"--help")) return help();
	from=strdup(argv[1]);
	if(argc<3) to=newname(from); else to=strdup(argv[2]);
	FROM=fopen(from, "r");
	if(!FROM||(int)FROM==-1) return printf("Error opening file: %s for reading, try s2k2smi --help\n", from);
	TO=fopen(to, "w");
	if(!TO||(int)TO==-1) return printf("Error opening file: %s for writing, try s2k2smi --help\n", to);
	fprintf(TO, head,from,28,256,256,0);
	while(fgets(buffer, 65536, FROM)){
		if(*buffer=='/' && *(buffer+1)=='/') continue; //ignore comment
		if(!henno_cmp(";Set.Time.Start=",buffer)){
								  
			timer=atoi(buffer+strlen(";Set.Time.Start="));
			continue;
		}
		if(*buffer!=';'){
				if(!strcmp(buffer," \n")) fprintf(TO,"<SYNC Start=%d><P>&nbsp;\n",timer);
				else fprintf(TO, "<SYNC Start=%d><P>%s\n",timer,buffer);
		}
	}
	fprintf(TO, foot);
	fclose(TO);
	fclose(FROM);
	return 0;
}
